package com.sams.learnweblogic7.ejb.cmp;

import java.rmi.RemoteException;
import javax.ejb.EJBObject;

import java.util.*;

/**
* This is the waiter interface, looked up by the restaurant, and passed to the client.
* This interface, which extends EJBObject, is the remote interface. The business methods are defined here.
*/

public interface WaiterInterface extends EJBObject
{
	public MenuList getMenu() throws RemoteException;
	public void getOrder(MenuItem orderedItem, int quantity) throws RemoteException;
	public void confirmOrder() throws RemoteException;
	public ChefInterface getChefFromChefPool() throws RemoteException;
	public Vector serveCookedItem() throws RemoteException;
	public float getCheck() throws RemoteException;
}