<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>
<%@ taglib uri="customTagsTLD.tld" prefix="ctt" %>
<!-- Creates an HTML page that is used to demonstrate the shopping cart example
Copyright (c) Sams Publishing Learn Weblogic 7.0 in 21 days. All Rights Reserved.-->
<%@ page import="com.sams.learnweblogic7.utils.*, com.sams.learnweblogic7.servlets.*, com.sams.learnweblogic7.tagLibClasses.*, java.util.*" %>
<%! Book book1; %>
<%! Book book2; %>
<%! Book book3; %>
<%! ServletContext sc; %>
<%! Hashtable shoppingCartHash = null; %>
<%! HttpSession session; %>
<%! private static final int DEFAULT_ZERO_VALUE = 0; %>
<%
		sc = getServletConfig().getServletContext();
		String clickedButton = (request.getParameter("buttonName") == null)?"":request.getParameter("buttonName");
		if(clickedButton.equals("Empty Shopping Cart"))
		weblogic.servlet.security.ServletAuthentication.invalidateAll(request);
		session = request.getSession(true);
		if(session.isNew()){

			//getting the init params
			String book1Id = config.getInitParameter("book1Id");
			String book1Name = config.getInitParameter("book1Name");
			double book1Price = new Double(config.getInitParameter("book1Price")).doubleValue();
			String book1Image = config.getInitParameter("book1Image");
			String book1Description = config.getInitParameter("book1Description");
			book1 = new Book(book1Id, book1Name, book1Price, book1Image, book1Description);
			sc.setAttribute("book1",book1);		

			String book2Id = config.getInitParameter("book2Id");
			String book2Name = config.getInitParameter("book2Name");
			double book2Price = new Double(config.getInitParameter("book2Price")).doubleValue();
			String book2Image = config.getInitParameter("book2Image");
			String book2Description = config.getInitParameter("book2Description");
			book2 = new Book(book2Id, book2Name, book2Price, book2Image, book2Description);
			sc.setAttribute("book2",book2);		

			String book3Id = config.getInitParameter("book3Id");
			String book3Name = config.getInitParameter("book3Name");
			double book3Price = new Double(config.getInitParameter("book3Price")).doubleValue();
			String book3Image = config.getInitParameter("book3Image");
			String book3Description = config.getInitParameter("book3Description");
			book3 = new Book(book3Id, book3Name, book3Price, book3Image, book3Description);
			sc.setAttribute("book3",book3);	

			//create an empty shopping cart hashtable, with zero quantity for each book id
			shoppingCartHash = new Hashtable();
			shoppingCartHash.put(book1.getBookId(), new Integer(DEFAULT_ZERO_VALUE));
			shoppingCartHash.put(book2.getBookId(), new Integer(DEFAULT_ZERO_VALUE));
			shoppingCartHash.put(book3.getBookId(), new Integer(DEFAULT_ZERO_VALUE));
			session.setAttribute("shoppingCartHash", shoppingCartHash);

		}
		else
		{
			
			book1 = (Book)sc.getAttribute("book1");
			book2 = (Book)sc.getAttribute("book2");
			book3 = (Book)sc.getAttribute("book3");

			if(clickedButton.equals("view"))
			{
					RequestDispatcher rd = sc.getRequestDispatcher("/ViewCartJsp");				
					//here, if you use include, it will show the view cart page, and the page following this scriplet tag
					rd.forward(request,response);
			}
			else if(clickedButton.equals("add"))
			{
				shoppingCartHash=(session.getAttribute("shoppingCartHash") == null)?new Hashtable():(Hashtable)session.getAttribute("shoppingCartHash");
				int Book1Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book1.getBookId())).toString(),DEFAULT_ZERO_VALUE)+Utility.getDefaultValue(request.getParameter("book1_qty"),DEFAULT_ZERO_VALUE);
				int Book2Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book2.getBookId())).toString(),DEFAULT_ZERO_VALUE)+Utility.getDefaultValue(request.getParameter("book2_qty"),DEFAULT_ZERO_VALUE);
				int Book3Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book3.getBookId())).toString(),DEFAULT_ZERO_VALUE)+Utility.getDefaultValue(request.getParameter("book3_qty"),DEFAULT_ZERO_VALUE);
				
				shoppingCartHash.put(book1.getBookId(), new Integer(Book1Qty));
				shoppingCartHash.put(book2.getBookId(), new Integer(Book2Qty));		
				shoppingCartHash.put(book3.getBookId(), new Integer(Book3Qty));

				session.setAttribute("shoppingCartHash", shoppingCartHash);
			}

		}
%>
<wl:cache name="commonHeader" scope="session">
<HTML>
<HEAD>
	<TITLE>
		Shopping Cart Example using Tag Library JSP's and HTTP session 
	</TITLE>
</HEAD>
<BODY>
<FORM name="addcart" action="/ShoppingApp/ShoppingCartJsp" method="post">
<B><font face = "Verdana" color="blue" size=-2><p align = "right">Shopping Cart using Tag Library JSP's and Http Session</p></font></B>
</wl:cache>
<CENTER><B>Most popular books from Sams Publishing</B></CENTER><BR>
<TABLE width = 100%>
<TR><TH>&nbsp;</TH><TH>Book Name and Description</TH><TH>Book Price</TH><TH>No of Books to add to cart</TH></TR>
<wl:cache name="book1Vars" scope="session"><TR bgcolor='#cccc99'><TD><img src="<%= book1.getImagePath()%>"></TD><TD align='left'><b><%=book1.getBookName()%></b><BR><%= book1.getBookDescription()%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=book1.getBookPrice()%>"/></TD></wl:cache><TD align='center'><INPUT type = 'text' name='book1_qty' size = 3></TD></TR>  
<wl:cache name="book2Vars" scope="session"><TR bgcolor='#eeeeee'><TD><img src="<%= book2.getImagePath()%>"></TD><TD align='left'><b><%=book2.getBookName()%></b><BR><%= book2.getBookDescription()%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=book2.getBookPrice()%>"/></TD></wl:cache><TD align='center'><INPUT type = 'text' name='book2_qty' size = 3></TD></TR>  
<wl:cache name="book3Vars" scope="session"><TR bgcolor='#cccc99'><TD><img src="<%= book3.getImagePath()%>"></TD><TD align='left'><b><%=book3.getBookName()%></b><BR><%= book3.getBookDescription()%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=book3.getBookPrice()%>"/></TD></wl:cache><TD align='center'><INPUT type = 'text' name='book3_qty' size = 3></TD></TR>  
</TD></TR></TABLE>
<BR>
<CENTER><TABLE width = 100%><TR>
<TD align="center"><INPUT type="submit" name="buttonName" value="add"></TD>
<TD align="center"><INPUT type="submit" name="buttonName" value="view"></TD>
</TR></TABLE></CENTER>
<wl:cache name="commonFooter" scope="session">
</FORM>
</BODY>
</HTML>
</wl:cache>

