<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>
<%@ taglib uri="customTagsTLD.tld" prefix="ctt" %>
<!-- Creates an HTML page that is used to demonstrate the shopping cart example
Copyright (c) Sams Publishing Learn Weblogic 7.0 in 21 days. All Rights Reserved.-->
<%@ page import="com.sams.learnweblogic7.utils.*, com.sams.learnweblogic7.servlets.*, java.util.*" %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>
<%! Book book1; %>
<%! Book book2; %>
<%! Book book3; %>
<%! ServletContext sc; %>
<%! Hashtable shoppingCartHash = null; %>
<%! HttpSession session; %>
<%! private static final int DEFAULT_ZERO_VALUE = 0; %>
<%
		sc = getServletConfig().getServletContext();
		book1 = (Book)sc.getAttribute("book1");
		book2 = (Book)sc.getAttribute("book2");
		book3 = (Book)sc.getAttribute("book3");

		shoppingCartHash=(session.getAttribute("shoppingCartHash") == null)?new Hashtable():(Hashtable)session.getAttribute("shoppingCartHash");

	  int book1Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book1.getBookId())).toString(),DEFAULT_ZERO_VALUE);
		int book2Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book2.getBookId())).toString(),DEFAULT_ZERO_VALUE);
		int book3Qty = Utility.getDefaultValue(((Integer)shoppingCartHash.get(book3.getBookId())).toString(),DEFAULT_ZERO_VALUE);
		double totBook1Price = Utility.getRoundedAmount(book1Qty * book1.getBookPrice());
		double totBook2Price = Utility.getRoundedAmount(book2Qty * book2.getBookPrice());
		double totBook3Price = Utility.getRoundedAmount(book3Qty * book3.getBookPrice());
		double grandTotal = totBook1Price + totBook2Price + totBook3Price;
		//adding these to the Servlet context
		sc.setAttribute("totBook1Price", new Double(totBook1Price));
		sc.setAttribute("totBook2Price", new Double(totBook2Price));
		sc.setAttribute("totBook3Price", new Double(totBook3Price));
		sc.setAttribute("grandTotal", new Double(grandTotal));
		sc.setAttribute("book1Qty",new Integer(book1Qty));
		sc.setAttribute("book2Qty",new Integer(book2Qty));
		sc.setAttribute("book3Qty",new Integer(book3Qty));

%>
<wl:cache name="commonHeader" scope="session">
</wl:cache>
<TABLE width = 100%>
<CENTER><B>Your Shopping Cart Contains:</B></CENTER><BR>
<TR><TH>&nbsp;</TH><TH>Book Name and description</TH><TH>Book Price</TH><TH>Qty</TH><TH>Total for each book</TH></TR>
<wl:cache name="book1Vars" scope="session"></wl:cache><TD align ='center'><%=book1Qty%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=totBook1Price%>"/></FONT></TD></TR>  
<wl:cache name="book2Vars" scope="session"></wl:cache><TD align ='center'><%=book2Qty%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=totBook2Price%>"/></FONT></TD></TR>  
<wl:cache name="book3Vars" scope="session"></wl:cache><TD align ='center'><%=book3Qty%></TD><TD align='center'><ctt:MoneyFormat MoneyValue="<%=totBook3Price%>"/></FONT></TD></TR>  
<TR bgcolor='#eeeeee'><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD align='left'><b>Total = <ctt:MoneyFormat MoneyValue="<%=grandTotal%>"/></b></FONT></TD></TR>
</TD></TR></TABLE>
<p align ="center"><INPUT type="submit" name="buttonName" value="Empty Shopping Cart"></p>
<wl:cache name="commonFooter" scope="session"></wl:cache>
