package com.sams.learnweblogic7.tagLibClasses;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import com.sams.learnweblogic7.utils.*;

/**
 * This class displays the amount in the requested format, or $ as default.
 */ 

public class MoneyFormat extends TagSupport{
  private double moneyValue;
  public int doStartTag() {
    System.out.println("Inside the tag in dostart");
	try{
		JspWriter out = pageContext.getOut();
		moneyValue = getMoneyValue();
		out.println(Utility.getMoneyFormat(moneyValue));
	  }
	catch(Exception e){
		System.out.println("Please check your code");
		e.printStackTrace();
	}
	finally{
		return(SKIP_BODY);
	}
  }

  public void setMoneyValue(double moneyVal){
	this.moneyValue = moneyVal;
  }

  public double getMoneyValue(){
	return moneyValue;
  }
}